'---------------------------------------------------------'
' ZX64 PETSCII VIEWER V.1.0 - CARLO SANTAGOSTINO (c) 2019 '
'---------------------------------------------------------'

' Define Functions

' convert colors code from C64 to ZXSpectrum
FUNCTION zxcol(x AS UBYTE) AS UBYTE
	IF x = 0 THEN
		x = 0 
		ELSE IF x = 1 THEN
			x = 7
		ELSE IF x = 2 THEN
			x = 2
		ELSE IF x = 3 THEN
			x = 5
		ELSE IF x = 4 THEN
			x = 3
		ELSE IF x = 5 THEN
			x = 4
		ELSE IF x = 6 THEN
			x = 1
		ELSE IF x = 7 THEN
			x = 6
		ELSE IF x = 8 THEN
			x = 2
		ELSE IF x = 9 THEN
			x = 6
		ELSE IF x = 10 THEN
			x = 3
		ELSE IF x = 11 THEN
			x = 1
		ELSE IF x = 12 THEN
			x = 7
		ELSE IF x = 13 THEN
			x = 4
		ELSE IF x = 14 THEN
			x = 1
		ELSE IF x = 15 THEN
			x = 7
	END IF
    RETURN x
END FUNCTION

' return bright value for colors from C64 to ZXSpectrum 
FUNCTION zxbri(x AS UBYTE) AS UBYTE
	IF x = 0 THEN
		x = 0
		ELSE IF x = 1 THEN
			x = 1
		ELSE IF x = 2 THEN
			x = 0
		ELSE IF x = 3 THEN
			x = 1
		ELSE IF x = 4 THEN
			x = 0
		ELSE IF x = 5 THEN
			x = 0
		ELSE IF x = 6 THEN
			x = 0
		ELSE IF x = 7 THEN
			x = 1
		ELSE IF x = 8 THEN
			x = 1
		ELSE IF x = 9 THEN
			x = 0
		ELSE IF x = 10 THEN
			x = 1
		ELSE IF x = 11 THEN
			x = 0
		ELSE IF x = 12 THEN
			x = 0
		ELSE IF x = 13 THEN
			x = 1
		ELSE IF x = 14 THEN
			x = 1
		ELSE IF x = 15 THEN
			x = 0
	END IF
	RETURN x
END FUNCTION

FUNCTION readcar() AS UBYTE
	DIM x as UBYTE
	DIM con AS UINTEGER
	LET con=PEEK (UINTEGER, @counter)
	x = PEEK (@petsciis+con)
	LET con=con+1
	POKE UINTEGER (@counter),con
	RETURN x
END FUNCTION

	' Change character set
	POKE UINTEGER 23606, @typeface-256

	' init variables
	DIM brd, pap, car, inv, bri AS UBYTE
	
    ' Initialize screen
100 INK 5: PAPER 1: BORDER 5: BRIGHT 0: FLASH 0: CLS
    PRINT AT 1,4;"**** ZX 64 BASIC V2 ****"
    PRINT AT 3,1;"48K RAM SYSTEM  ALL BYTES FREE"
	PRINT AT 5,0;"READY."
	PRINT FLASH 1;AT 6,0;" "
     
    PAUSE 80
	
	PRINT FLASH 0;AT 6,0;" "
    
	'hint CHR$ 8 step back one character
	RANDOMIZE
	PRINT
	LET scritta$="--------------------------------"+"ZX SPECTRUM PETSCII VIEWER V1.0 "+"--------------------------------"+" BY CARLO SANTAGOSTINO (C)2019  "+"--------------------------------"+"    PRESS ANY KEY TO START!"
	FOR x = 0 TO LEN scritta$
		PRINT FLASH 0;scritta$(x);FLASH 1;" ";
		PRINT CHR$ 8;
		BEEP 0,0
		PAUSE (RND*10)+1
	NEXT x

	PAUSE 0

	POKE UINTEGER @counter,0
	
	'slide show
	FOR f=0 to 9
		CLS
		GO SUB PrintPetscii
		PAUSE 0
	NEXT f
	
	GO TO 100

PrintPetscii:
	BORDER 0 : PAPER 0 : INK 4
	CLS
	
	brd = readcar()
	pap = readcar()
	
	'read col
	FOR b=0 TO 23
	' skip left characters
	FOR a=0 TO 3:car=readcar():NEXT a
	'read line
	FOR a=0 TO 31
		car=readcar()

		LET inv = 0
		IF car >= 224 AND car < 256 THEN
			car=car-64 : inv=1
		ELSE IF car >= 192 AND car < 224 THEN
			car=car-96 : inv=1
		ELSE IF car >= 160 AND car < 192 THEN
			car=car-128 : inv=1
		ELSE IF car >= 128 AND car < 160 THEN
			car=car-64 : inv=1
		ELSE IF car >= 96 AND car < 128 THEN
			car=car+64
		ELSE IF car >= 64 AND car < 96 THEN
			car=car+32
		ELSE IF car >= 0 AND car < 32 THEN
			car=car+64
		END IF
		
		IF car >= 181 AND car < 192 THEN
			POKE UINTEGER 23675, @typeface+1024
			PRINT INVERSE inv;CHR$((car-181)+144);
		ELSE IF car >=160 AND car < 181 THEN
			POKE UINTEGER 23675, @typeface+768
			PRINT INVERSE inv;CHR$((car-160)+144);
		ELSE IF car >= 32 AND car < 160 THEN
			PRINT INVERSE inv;CHR$(car);
		END IF
	NEXT a
	' skip right characters
	FOR a=0 TO 3:car=readcar():NEXT a
	NEXT b

	' skip 1 line
	FOR a=0 to 39:car=readcar():NEXT a
	
	' set border color
	BORDER zxcol(brd)
	' set ink colors
	FOR b=0 TO 23
	FOR a=0 TO 3:car=readcar(): NEXT a
	FOR a=0 TO 31
		car=readcar()
		PRINT OVER 1;PAPER zxcol(pap);BRIGHT zxbri(car);INK zxcol(car);" ";
	NEXT a
	FOR a=0 TO 3:car=readcar(): NEXT a
	NEXT b

	' skip 1 line
	FOR a=0 to 39:car=readcar():NEXT a

	RETURN

typeface:
	asm
		incbin "PETSCII_VIEW.chr"
	end asm

counter:

petsciis:
	asm
		incbin "collection1.petscii"
		incbin "collection2.petscii"
	end asm
